import { Component, ViewChild, OnInit, ElementRef, EventEmitter, Output, Inject } from '@angular/core';
import { MatPaginator, MatPaginatorIntl } from '@angular/material/paginator';
import { MatTableDataSource } from '@angular/material/table';
import { SelectionModel } from '@angular/cdk/collections';
import { ThemePalette } from '@angular/material/core';
import { NivelEducativoService } from '../../services/nivel-educativo.service';

import { FormControl, FormGroup, Validators } from '@angular/forms';
import { MatIconRegistry } from '@angular/material/icon';
import { DomSanitizer } from '@angular/platform-browser';
import * as XLSX from 'xlsx';
import { EnviarInfoService } from '../../services/enviar-info.service';
import { dA } from '@fullcalendar/core/internal-common';
import Swal from 'sweetalert2';
import { MAT_DIALOG_DATA, MatDialog } from '@angular/material/dialog';
import { NivelEducativo } from '../../interfaces/NivelEducativo.interface';
import { HttpClient } from '@angular/common/http';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { Router } from '@angular/router';
import { ButtonDialogComponent } from '../../components/button-dialog/button-dialog.component';
import { ExportExcellService } from '../../services/export-excell.service';

export class AppModule { }


@Component({
  selector:'app-niveles-educativos',
  templateUrl: './niveles-educativos.component.html',
  styleUrls: ['./niveles-educativos.component.css'],
})
export class NivelesEducativosComponent implements OnInit {
  public checked = false;
  public isLoading: boolean = true;
  public searchInput = new FormControl('');
  public color: string = '';
  public textColor: string = '';
  public columnas: string[] = ['claveNivel', 'nombreNivel', 'estado', 'acciones'];
  public dataSource = new MatTableDataSource<NivelEducativo>();
paginaActual: number = 1;  // <-- Declara la variable aquí

  // tu código...

  cambiarPagina(nuevaPagina: number) {
    this.paginaActual = nuevaPagina;
  }

  @ViewChild(MatPaginator, { static: true }) paginator!: MatPaginator;
  @ViewChild('TABLE') table!: ElementRef;


  constructor(
    private _nivelEducativoService: NivelEducativoService,
    private _MatIconRegister: MatIconRegistry,
    private _DomSanitizer: DomSanitizer,
    private paginatorIntl: MatPaginatorIntl,
    private _enviarInfo: EnviarInfoService,
    public dialog: MatDialog,
    private http: HttpClient,
    private exportExcell: ExportExcellService

  ) {
    this._MatIconRegister.addSvgIcon('excel', this._DomSanitizer.bypassSecurityTrustResourceUrl('assets/icons/excel.svg'));
    //paginador de tabla a español
    const spanishRangeLabel = (page: number, pageSize: number, length: number): string => {
      if (length === 0 || pageSize === 0) {
        return `0 de ${length}`;
      }
      length = Math.max(length, 0);
      const startIndex = page * pageSize;
      const endIndex = startIndex < length ?
        Math.min(startIndex + pageSize, length) :
        startIndex + pageSize;
      return `${startIndex + 1} - ${endIndex} de ${length}`;
    };
    this.paginatorIntl.nextPageLabel = "Siguiente";
    this.paginatorIntl.previousPageLabel = "Anterior";
    this.paginatorIntl.firstPageLabel = "Ir a la primer página";
    this.paginatorIntl.lastPageLabel = "Ir a la última página";
    this.paginatorIntl.itemsPerPageLabel = "Registros por página";
    this.paginatorIntl.getRangeLabel = spanishRangeLabel;
  }

  ngOnInit(): void {
    this._enviarInfo.currentTextColor.subscribe(textColor => {
      this.textColor = textColor;
    });
    this._enviarInfo.currentColor.subscribe(color => {
      this.color = color;
    });

    //suscribirse al subject que manda al servicio
    this._enviarInfo.tabla$.subscribe(() => {
      this.getNiveles();
    });

    this.getNiveles()
  }
  public allInfo: any;

  //Traer la información y mostrarla en la tabla
  getNiveles() {
    return this._nivelEducativoService.getAllNivel().subscribe((response: any) => {
      this.isLoading = false;
      this.allInfo = response
      this.dataSource = new MatTableDataSource<NivelEducativo>(this.allInfo.filter((filtro:any) => filtro.estado === 'Activo'));
      this.dataSource.paginator = this.paginator;
      console.log(response);

      return response;
    })
  }

  option(event: string) {
    this.isLoading = true;
    let filteredData: any;

    if (event === 'Activos') {
      filteredData = this.allInfo.filter((filtro:any) => filtro.estado === 'Activo');
    } else if (event === 'Eliminados') {
      filteredData = this.allInfo.filter((filtro:any) => filtro.estado === 'Eliminado');
    }

    this.dataSource = new MatTableDataSource<NivelEducativo>(filteredData);
    this.dataSource.paginator = this.paginator;
    this.isLoading = false;
  }


  //filtro de búsqueda
  applyFilter(event: Event) {
    const filterValue = (event.target as HTMLInputElement).value;
    this.dataSource.filter = filterValue.trim().toLowerCase();
  }




  //exportar búsqueda a excel
  exportarTodo() {
    this.exportExcell.exportAll('niveles');
  }

  // 🔹 Exportar una página
  // exportarPagina(pagina: number) {
  //   this.exportExcell.exportAll('niveles', pagina);
  // }
private nombreArchivo(tabla: string): string {
  switch (tabla) {
    case 'niveles': return 'Niveles_Educativos';
    case 'materias_categorias': return 'Categorias_Materias';
    case 'materias': return 'Materias';
    case 'grados': return 'vista_grados_niveles';
    case 'grupos': return 'Grupos';
    case 'usuarios': return 'Usuarios';
    case 'tipos_tareas': return 'Tipos_Tareas';
    default: return 'Reporte';
  }
}









  deleteLevel(id: string) {

    Swal.fire({
      icon: 'question',
      title: '¿Desea cambiar el estado del nivel?',
      showCancelButton: true,
      allowOutsideClick: false,
      allowEscapeKey: false,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: "Eliminar",
    }).then((result: any) => {
      /* Read more about isConfirmed, isDenied below */
      if (result.isConfirmed) {
        this._nivelEducativoService.eliminarNivel(id).subscribe((response: any) => {
          console.log(response);
          Swal.fire({
            icon: 'success',
            title: 'Nivel educativo eliminado',
            confirmButtonColor: 'rgb(237,46,56)',
            confirmButtonText: 'Ok',
          }).then((result: any) => {

            if (result.isConfirmed) {
              this.ngOnInit();
              Swal.close();
            }
          })
        }, (err) => {
          console.log(err);
          Swal.fire({
            icon: 'error',
            title: 'Error al eliminar',
            text: `${err.error.mensaje}`,
          })
          this.ngOnInit();
        }
        )
      } else if (result.dismiss == 'cancel') {
        this.ngOnInit();
      }
    });

  }

  enableLevel(id: string) {
    Swal.fire({
      icon: 'question',
      title: '¿Desea habilitar el nivel?',
      showCancelButton: true,
      allowOutsideClick: false,
      allowEscapeKey: false,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: "Habilitar",
    }).then((result: any) => {

      if (result.value) {
        this._nivelEducativoService.habilitarNivel(id).subscribe((response: any) => {
          Swal.fire({
            icon: 'success',
            title: 'Nivel educativo habilitado',
            confirmButtonColor: 'rgb(237,46,56)',
            confirmButtonText: 'Ok',
          }).then((result: any) => {
            if (result.isConfirmed) {
              Swal.close();
              this.ngOnInit();
            }
          })
        }, (err) => {
          console.log(err);
          Swal.fire({
            icon: 'error',
            title: 'Error al habilitar',
            text: `${err.error.message}`,
          })
        }
        )
      } else if (result.dismiss == 'cancel') {
        this.ngOnInit();
      }
    });
  }

  openDialog(nivel:any) {
    const dialogRef = this.dialog.open(ModalNiveleducativoEdit, {
      autoFocus: false,
      data: {clave: nivel.idNivel, nombre: nivel.nombreNivel}
    });

    //esto es para actualizar la tabla una vez actualizada la info
    dialogRef.componentInstance.nivelActualizado.subscribe(() => {
      this.getNiveles();
    });
  }




}


@Component({
  selector: 'dialog-content-example-dialog',
  templateUrl: 'editar.component.html',
  styleUrl: './niveles-educativos.component.css'

})

export class ModalNiveleducativoEdit {

  // public data: any;

  public widowWidth!: number;
  //esto es para actualizar la tabla
  @Output() nivelActualizado = new EventEmitter<void>();
  constructor(public dialog: MatDialog,
    private nivelEducativoService: NivelEducativoService,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) {
    this.setData();
  }

  public form = new FormGroup({
    idNivel: new FormControl<string>({ value: '', disabled: true }, Validators.required),
    nombreNivel: new FormControl<string>('', [Validators.required, Validators.pattern('^(?!\\s)[a-zA-Z0-9 ]*$')]),
  })
  setData() {

      // mostrar data en el formulario
      this.form.controls['idNivel'].setValue(this.data.clave);
      this.form.controls['nombreNivel'].setValue(this.data.nombre);

  }

  editNivelEducativo() {
    console.log('data' + this.data);
    console.log(this.form.value);
    let info = {
      id: this.data.clave,
      idNivel: this.data.clave,
      nombreNivel: this.form.value.nombreNivel,
    }
    if (this.form.invalid) {
      return Object.values(this.form.controls).forEach(control => {
        control.markAllAsTouched();
        Swal.fire({
          icon: 'error',
          title: `Por favor, ingrese información válida en el formulario.`
        })
      });
    }
    console.log(info);
    this.nivelEducativoService.actualizarNivel(info).subscribe((response: any) => {
      console.log(response);
      Swal.fire({
        icon: 'success',
        title: `${response.mensaje}`
      })
      this.dialog.closeAll();
      this.nivelActualizado.emit();
    }, (err) => {
      console.log(err);
      Swal.fire({
        icon: 'error',
        title: `${err.message}`
      })
    })
  }

  close() {
    this.dialog.closeAll()
  }

  limpiar() {
    this.form.reset();
  }

  campoNoValido(campo: string): boolean {
    if (this.form.get(campo)?.invalid && this.form.get(campo)?.touched) {
      return true;
    } else {
      return false;
    }
  }

  campoVacio(campo: string): boolean {
    if ((this.form.get(campo)?.value === '' || this.form.get(campo)?.invalid) && this.form.get(campo)?.touched) {
      return true;
    } else {
      return false;
    }
  }
}
